if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallRoutes' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_CallRoutes' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'Code' )
	Alter Table dbo.A_CallRoutes
	Add Code nvarchar ( 100 )
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallRoutes' ) )
	Update A_CallRoutes
	Set Code = ''
	Where Code is Null
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallRoutes_GetAll' ) )
	Drop procedure dbo.A_CallRoutes_GetAll
GO

Create procedure dbo.A_CallRoutes_GetAll
as
begin
	Select Id, Name, Description, Command, IsExternal, Enabled, Type, Code
	From A_CallRoutes
	Order By Name
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallRoutes_Save' ) )
	Drop procedure dbo.A_CallRoutes_Save
GO

Create procedure dbo.A_CallRoutes_Save
	@id uniqueidentifier,
	@name nvarchar ( 200 ),
   	@description nvarchar ( 1000 ),
   	@command nvarchar ( 1000 ),
	@isexternal bit,
	@enabled bit,
	@type int,
	@code nvarchar ( 100 ) = ''
as
begin
	Update A_CallRoutes
	Set 	Name = @name,
		Description = @description,
		Command = @command,
		IsExternal = @isexternal,
		Enabled = @enabled,
		Type = @type,
		Code = @code
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert into A_CallRoutes ( Id, Name, Description, Command, IsExternal, Enabled, Type, Code )
		Values ( @id, @name, @description, @command, @isexternal, @enabled, @type, @code )
end

GO