
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_UpdateOperatorStates' ) )
	Drop procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
GO


Create Procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
	@dtnow datetime = null
as
begin

set dateformat dmy

if ( @dtnow is null )
	set @dtnow = GetDate()

if not exists ( Select * FROM master..sysdatabases where name like 'oktell_cc_temp' )
	return

--Declare @fulllogdt DateTime
--Declare @logdt DateTime
--Declare @operlogdt DateTime
Declare @sqltext nvarchar ( 4000 )

Declare @idempty uniqueidentifier
Set @idempty = '00000000-0000-0000-0000-000000000000'

--print '   ## start creating temp tables ' + Cast ( DatePart ( hh, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( mm, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print 's 00  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print '--------------------------------------start-- ms:  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )
--Set @fulllogdt = GetDate ( )

--      
Declare @dtsall DateTime
Select @dtsall = Min ( LastDT ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
if ( @dtsall is null )
	Set @dtsall = DateAdd ( d, -10, @dtnow )

--set @dtsall = '6.10.2007 14:20'
--print @dtsall
--print 's 01  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	

Declare @sc table ( FromCC bit, IsBetweenUsers bit, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, AUserId uniqueidentifier, BUserId uniqueidentifier )

/*
Insert Into @sc
	Select FromCC, IsBetweenUsers, TimeStart, TimeAnswer, TimeStop, AUserId, BUserId
	From A_Stat_Connections_1x1 sc With ( TabLock )
	Where TimeStart > @dtsall Or TimeStop > @dtsall Or TimeStop is null

print 's 02_1  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
*/

	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#tmpos01' ) )
		Drop Table #tmpos01
	Create table #tmpos01 ( FromCC bit, IsBetweenUsers bit, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, AUserId uniqueidentifier, BUserId uniqueidentifier )

	set @sqltext = 'Select FromCC, IsBetweenUsers, TimeStart, TimeAnswer, TimeStop, AUserId, BUserId 
		From A_Stat_Connections_1x1 sc With ( NOLOCK )
		Where ( TimeStart > @dtt1 Or TimeStop > @dtt1 Or TimeStop is null ) And ( TimeStart < @dtnow )'
	Insert Into #tmpos01
		exec sp_executesql @sqltext, N'@dtt1 datetime, @dtnow datetime', @dtsall, @dtnow
	Insert into @sc
		Select * FROM #tmpos01

	drop table #tmpos01


--print 's 02_2  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	

Declare @ush table ( OperatorId uniqueidentifier, State int, TimeEnter DateTime, TimeLeave DateTime, Info nvarchar ( 100 ) collate database_default, ICode int)

/*
Insert into @ush
	Select OperatorId, State, TimeEnter, TimeLeave, case when selfinfo = 1 then Info else '' end
	From A_CallCenter_UserStateHistory with ( TabLock )
	Where ( TimeEnter > @dtsall Or TimeLeave > @dtsall Or TimeLeave is null )

*/
	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#tmpos02' ) )
		Drop Table #tmpos02
	Create table #tmpos02 ( OperatorId uniqueidentifier, State int, TimeEnter DateTime, TimeLeave DateTime, Info nvarchar ( 100 ) collate database_default, ICode int )

	set @sqltext = 'Select OperatorId, State, TimeEnter, TimeLeave, case when selfinfo = 1 then Info else '''' end Info, ICode
		From A_CallCenter_UserStateHistory With ( NOLOCK )
		Where ( TimeEnter > @dtt1 Or TimeLeave > @dtt1 Or TimeLeave is null ) And ( TimeEnter < @dtnow )'

	Insert Into #tmpos02
		exec sp_executesql @sqltext, N'@dtt1 datetime, @dtnow datetime', @dtsall, @dtnow
	Insert into @ush
		Select * FROM #tmpos02	

	drop table #tmpos02


Declare @uit table ( Id uniqueidentifier, UserId uniqueidentifier, TaskId uniqueidentifier, EffortId uniqueidentifier, TimeStart DateTime, TimeStopPrior DateTime, TimeStopWaitCall DateTime, TimeStopBackCall DateTime, TimeStopDialog DateTime, TimeStopPost DateTime )
/*
Insert into @uit
	Select Id, UserId, TaskId, Effortid, IsNull ( TimeStart, @dtnow ), IsNull ( TimeStopPrior, @dtnow ), IsNull ( TimeStopWaitCall, @dtnow ), IsNull ( TimeStopBackCall, @dtnow ), IsNull ( TimeStopDialog, @dtnow ), IsNull ( TimeStopPost, @dtnow )
	From A_TaskManager_UserInTask
	Where TimeStart >= @dtsall or TimeStopPost >= @dtsall or TimeStopPost is null
*/
	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#tmpos03' ) )
		Drop Table #tmpos03
	Create table #tmpos03 ( Id uniqueidentifier, UserId uniqueidentifier, TaskId uniqueidentifier, EffortId uniqueidentifier, TimeStart DateTime, TimeStopPrior DateTime, TimeStopWaitCall DateTime, TimeStopBackCall DateTime, TimeStopDialog DateTime, TimeStopPost DateTime )

	set @sqltext = 'Select Id, UserId, TaskId, Effortid, IsNull ( TimeStart, @dtnow ), IsNull ( TimeStopPrior, @dtnow ), IsNull ( TimeStopWaitCall, @dtnow ), IsNull ( TimeStopBackCall, @dtnow ), IsNull ( TimeStopDialog, @dtnow ), IsNull ( TimeStopPost, @dtnow )
	From A_TaskManager_UserInTask With ( NOLOCK )
	Where ( TimeStart >= @dtt1 or TimeStopPost >= @dtt1 or TimeStopPost is null ) And ( TimeStart < @dtnow )'

	Insert Into #tmpos03
		exec sp_executesql @sqltext, N'@dtt1 datetime, @dtnow datetime', @dtsall, @dtnow
	Insert into @uit
		Select * FROM #tmpos03	

	drop table #tmpos03


Declare @umaxdts table ( UserId uniqueidentifier, MaxDTS DateTime  )

Insert into @umaxdts
	Select IdOperator, Max ( DateTimeStop ) 
	From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] With ( NOLOCK )
	Group By IdOperator

--print '   ## created all tables. Starting cursor cycle ' + Cast ( DatePart ( hh, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( mm, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print '-----shared-sc- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )


--   
Declare @settable table ( Id uniqueidentifier, Name nvarchar ( 100 ) collate database_default)
Insert into @settable
	Select Id, Name From A_Users u 
		Inner join A_UserParams up on u.Id = up.IdUser
	Where IsOperator = 1

--return

Begin Tran TranUpdateOperatorStates

Declare ucursor Cursor LOCAL FAST_FORWARD For 
	Select Id, Name From @settable

Declare @idoperator uniqueidentifier, @nameoperator nvarchar ( 100 )	

--Set @operlogdt = @dtnow

Open ucursor
Fetch Next From ucursor Into @idoperator, @nameoperator

While ( @@fetch_status = 0 )
   begin

	Declare @id uniqueidentifier
	Select @id = Id from [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
	Where Id = @idoperator
	if ( @@rowcount = 0 )
		Insert 
		Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
		( Id, Name ) Values ( @idoperator, @nameoperator )
				
				
	--     
	Declare @dts DateTime, @dts1 DateTime

	/*
	Max ( DateTimeStop ) 
	From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
	Where IdOperator = @idoperator	
	*/
	Select @dts = MaxDTS
	From @umaxdts
	Where UserId = @idoperator
	
	Select @dts1 = LastDT
	From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	Where Id = @idoperator
	
	if ( @dts1 > @dts ) or ( @dts is null )
		Set @dts = @dts1
	
	if ( @dts is null )
		set @dts = '01.01.2000'

	--print '-----def------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @operlogdt = GetDate ( )


	--          
	if ( Cast ( @dtnow - @dts as float ) * 1440 > 1 )
	   begin		

		/*
		PriorHandle		= 1,
		WaitingCall		= 2,
		BackRing		= 3,
		TalkAbonent		= 4,
		TalkInside		= 5,
		InsideTalk		= 6,
		PostHandle		= 7,
		TalkOther		= 8,
		CCLunch			= 9,
		CCReady			= 10,
		System			= 11
		*/

		-----------------------------------------------------
		--   (   ) ----------
		-----------------------------------------------------
		Declare @tempo2 table
		(
			State int not null,
			Priority int,
			DateTimeStart DateTime,
			DateTimeStop DateTime,
			Id int Identity ( 1, 1 ) not null primary key,
			Info nvarchar ( 100 ),
			ICode int
		)

		Delete From @tempo2

		Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info, ICode )
			Select State, Case when State in ( 3, 4 ) then 2 else 4 end, 
				TimeEnter, IsNull ( TimeLeave, @dtnow ), Info, ICode
			From @ush
			Where OperatorId = @idoperator
				And State in ( 2, 3, 4 )
				And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )
		
		Update @tempo2
		Set State = Case When Priority = 2 then 9 else 10 end

		
		--      - 
		if ( @@rowcount > 0 )
		begin	
			--      
			Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info, ICode )
				Select 11, 5, TimeEnter, IsNull ( TimeLeave, @dtnow ), Info, ICode
				From @ush
				Where OperatorId = @idoperator
					And State = 0
					And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )

			Update @tempo2			
			Set 	DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				DateTimeStop = Case When DateTimeStop > @dtnow then @dtnow else DateTimeStop end
			

			--print '-----t2--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

	
			-----------------------------------------------------
			--   (   ) -----
			-----------------------------------------------------
			Declare @tempo1 table
			(
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int not null,
				StateCat	int,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float,
				IdEffort	uniqueidentifier,
				Priority	int,
				Id		int identity ( 1, 1 ) not null primary key
			)

			Delete From @tempo1
			
			Declare @uito table 
			(
				Id uniqueidentifier,
				UserId uniqueidentifier,
				TaskId uniqueidentifier,	
				EffortId uniqueidentifier,
				TimeStart DateTime,
				TimeStopPrior DateTime,
				TimeStopWaitCall DateTime,
				TimeStopBackCall DateTime,
				TimeStopDialog DateTime,
				TimeStopPost DateTime
			)

			Delete From @uito

			Insert Into @uito
			Select *
			From @uit
			Where UserId = @idoperator
				--And ( TimeStart > @dts or TimeStopPost > @dts or TimeStopPost is null )

			--print '-----t1-crtemp-- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 1, 0, 
					TimeStart, 
					TimeStopPrior
				From @uito--#t
				Where Cast ( TimeStopPrior - TimeStart as float ) * 86400 > 0
			
			--print '-----t1-cra----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
			
			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,

						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 2, 0, 
					TimeStopPrior, 
					TimeStopWaitCall
				From @uito--#t
				Where Cast ( TimeStopWaitCall - TimeStopPrior as float ) * 86400 > 0

			--print '-----t1-crb----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 3, 0, 
					TimeStopWaitCall, 
					TimeStopBackCall
				From @uito--#t
				Where Cast ( TimeStopBackCall - TimeStopWaitCall as float ) * 86400 > 0

			--print '-----t1-crc----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 6, 0, 
					TimeStopBackCall, 
					TimeStopDialog
				From @uito--#t
				Where Cast ( TimeStopDialog - TimeStopBackCall as float ) * 86400 > 0

			--print '-----t1-crd----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 7, 0, 
					TimeStopDialog,
					TimeStopPost
				From @uito--#t
				Where Cast ( IsNull ( TimeStopPost, @dtnow ) - IsNull ( TimeStopDialog, @dtnow ) as float ) * 86400 > 0

			--print '-----t1-cre----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			--       
			Update @tempo1 
			Set 	DateTimeStart = case 	When ( DateTimeStart < @dts ) then @dts 
							else DateTimeStart end,
		 		DateTimeStop = case 	When ( DateTimeStop > @dtnow ) then @dtnow 
							When ( DateTimeStop < @dts ) then @dts 
							else DateTimeStop end

			Delete From @tempo1
			Where DateTimeStart = DateTimeStop


			--   / 
			Update tmpo
			Set IsOutput = t.IsOutputTask
			From @tempo1 tmpo, A_TaskManager_Tasks t
			Where tmpo.IdTask = t.Id

			--    
			Update tmpo
			Set CallResult = tic.CallResult
			From @tempo1 tmpo, A_TaskManager_Task_IncomingCalls tic
			Where tmpo.IdEffort = tic.Id

			Update tmpo
			Set CallResult = ste.EResult
			From @tempo1 tmpo, A_TaskManager_SubTaskEfforts ste
			Where tmpo.IdEffort = ste.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo1

			--Select * FROM A_Taskmanager_UserInTask


			--print '-----t1-up------ ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
	
			-----------------------------------------------------
			--   () -----------------------
			-----------------------------------------------------
			
			Declare @tempo3 table
			(
				State int not null,
				Priority int,
				DateTimeStart DateTime,
				DateTimeStop DateTime,
				Id int identity ( 1, 1 ) not null primary key
			)
			
			Delete From @tempo3
						
			Insert into @tempo3
				Select 8, 0, TimeStart, isnull ( TimeStop, @dtnow )
				From @sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
					And FromCC = 0
				/*
				Select Case When FromCC = 0 then 8 When IsBetweenUsers = 1 then 5 else 4 end, 0,
					TimeStart, isnull ( TimeStop, @dtnow )
				From @sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
				*/

			Update @tempo3
			Set DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				Priority = Case When State = 8 then 3 else 0 end
			
			
			--print '-----t3--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-----------------------------------------------------
			--     ---------------------
			-----------------------------------------------------

	--		Select * FROM @tempo1
	--		Select * FROM @tempo2
	--		Select * From @tempo3

	--		Select * FROM @tempo1 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * FROM @tempo2 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * From @tempo3 Where DateTimeStart > '13.02.2007' Order by DateTimeStart

		
			Declare @tempo table
			(
				TableN int,
				TableID int,
				State int not null,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete from @tempo

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStart, 0
				From @tempo1

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStop, 1
				From @tempo1

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStart, 0
				From @tempo2

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStop, 1
				From @tempo2

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStart, 0
				From @tempo3

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStop, 1
				From @tempo3
			
			--Select * From @tempo Order By DT

			--print '-----tpt-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		
			-----------------------------------------------------
			--   -------------------------------
			-----------------------------------------------------

			Declare @res table ( TableN int, Id int, State int not null, Priority int, DStart DateTime, DStop DateTime )
			Delete From @res

			--        
			-- : 	0 -    (  )
			--		1 -     (  )
			--		2 - 
			--		3 -  
			--		4 -   
			--		5 -   
			Declare @p0 int, @p1 int, @p2 int, @p3 int, @p4 int, @p5 int
			Declare @s0 int, @s1 int, @s2 int, @s3 int, @s4 int, @s5 int
			Declare @t0 int, @t1 int, @t2 int, @t3 int, @t4 int, @t5 int
			Declare @i0 int, @i1 int, @i2 int, @i3 int, @i4 int, @i5 int

			Select @p0 = 0, @p1 = 0, @p2 = 0, @p3 = 0, @p4 = 0	
			Select 	@p0 = IsNull ( P0, 0 ), @p1 = IsNull ( P1, 0 ), @p2 = IsNull ( P2, 0 ), @p3 = IsNull ( P3, 0 ), @p4 = IsNull ( P4, 0 ), @p5 = IsNull ( P5, 0 ),
				@s0 = IsNull ( S0, 0 ), @s1 = IsNull ( S1, 0 ), @s2 = IsNull ( S2, 0 ), @s3 = IsNull ( S3, 0 ), @s4 = IsNull ( S4, 0 ), @s5 = IsNull ( S5, 0 )

			From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
			Where Id = @idoperator
		
			--   	

			Declare @tempo_ordered table
			(
				Id int identity ( 1, 1 ) not null,
				TableN int,
				TableID int,
				State int not null,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete From @tempo_ordered

			Insert into @tempo_ordered ( TableN, TableID, State, Priority, DT, NK )
				Select TableN, TableID, State, Priority, DT, NK From @tempo
				Order By DT

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * From @tempo_ordered


			Declare @tempo_joined table
			(
				s1 int not null, p1 int not null, s2 int not null, p2 int not null, dstart datetime, dstop datetime, nk1 bit, nk2 bit, t1 int, t2 int, i1 int, i2 int
			)
			Delete From @tempo_joined
		
			Insert into @tempo_joined 
				Select t1.State as s1, t1.Priority as p1, t2.State as s2, t2.Priority as p2,
					t1.DT as dstart, t2.DT as dstop, t1.NK as nk1, t2.NK as nk2,
					t1.TableN, t2.TableN, t1.TableID, t2.TableID
				From @tempo_ordered t1
					Inner join @tempo_ordered t2 on t1.Id + 1 = t2.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo_joined

			--print '-----tjnd------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			--       
			Declare tcursor Cursor LOCAL FAST_FORWARD For 
				Select s1, p1, s2, p2, dstart, dstop, nk1, nk2, t1, t2, i1, i2 
				From @tempo_joined
				--Where dstart > '21.02.2007'

			Declare @st1 int, @pr1 int, @st2 int, @pr2 int, @dstart DateTime, @dstop DateTime, @nk1 bit, @nk2 bit, @tb1 int, @tb2 int, @id1 int, @id2 int
			Declare @actualst int, @actualpr int, @actualt int, @actualid int
			Declare @lastst int, @lastpr int, @lastt int, @lastid int, @lastdstart datetime, @lastdstop datetime
			Declare @dontinsert bit, @updatelast bit
			Declare @insertindex int

			set @insertindex = 0
			set @lastt = 0
			set @dontinsert = 1 --     (   )   
		
			Open tcursor
			Fetch Next From tcursor Into @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2

			While @@FETCH_STATUS = 0
   			Begin
				----print Cast ( @st1 as nvarchar ( 10 ) ) + '  ' + Cast ( @pr1 as nvarchar ( 10 ) ) + '  ' + Cast (  @st2 as nvarchar ( 10 ) ) + '  ' + Cast (  @pr2 as nvarchar ( 10 ) )  + '  //  ' +
				--	Cast ( @lastst as nvarchar ( 10 ) ) + '  ' + Cast ( @lastpr as nvarchar ( 10 ) )    + '  //  ' + 
				--	Cast ( @p0 as nvarchar ( 10 ) ) + '  ' + Cast ( @p1 as nvarchar ( 10 ) ) + '  ' + Cast (  @p2 as nvarchar ( 10 ) ) + '  ' + Cast (  @p3 as nvarchar ( 10 ) )
			
				---    -----		
				if ( @nk1 = 0 )
				begin			
					if ( @pr1 = 0 )
					begin
			    			set @p0 = @p0 + 1
				    		set @s0 = @st1				
						set @t0 = @tb1	
						set @i0 = @id1
					end
					else if ( @pr1 = 1 )
					begin
				    		set @p1 = @p1 + 1
				    		set @s1 = @st1
						set @t1 = @tb1
						set @i1 = @id1
					end
					else if ( @pr1 = 2 )
					begin
			    			set @p2 = @p2 + 1
				    		set @s2 = @st1
						set @t2 = @tb1
						set @i2 = @id1
					end
					else if ( @pr1 = 3 )
					begin
				    		set @p3 = @p3 + 1
				    		set @s3 = @st1
						set @t3 = @tb1
						set @i3 = @id1
					end
					else if ( @pr1 = 4 )
					begin
			    			set @p4 = @p4 + 1
				    		set @s4 = @st1
						set @t4 = @tb1
						set @i4 = @id1
					end
					else if ( @pr1 = 5 )
					begin
						set @p5 = @p5 + 1
						set @s5 = @st1
						set @t5 = @tb1
						set @i5 = @id1
					end
				end

				---    
				set @dontinsert = 0
				if ( @p0 > 0 )
				begin
					set @actualst = @s0
					set @actualpr = 0
					set @actualt = @t0
					set @actualid = @i0
				end
				else if ( @p1 > 0 )
				begin
					set @actualst = @s1
					set @actualpr = 1
					set @actualt = @t1
					set @actualid = @i1

				end
				else if ( @p2 > 0 )
				begin
					set @actualst = @s2
					set @actualpr = 2
					set @actualt = @t2
					set @actualid = @i2
				end
				else if ( @p3 > 0 )
				begin
					set @actualst = @s3
					set @actualpr = 3
					set @actualt = @t3
					set @actualid = @i3
				end
				else if ( @p4 > 0 )
				begin
					set @actualst = @s4
					set @actualpr = 4
					set @actualt = @t4
					set @actualid = @i4
				end
		
				--     4  2  (  )
				--        
				if (( @p4 = 0 ) and ( @p2 = 0 )) or ( @p5 = 0 )
 				set @dontinsert = 1
			
				--print Convert ( nvarchar ( 10 ), @dstart, 108 ) + ' ' + convert ( nvarchar ( 10 ), @dstop, 108 ) + ' state1=' + cast ( @st1 as nvarchar ( 10 ) ) + ' state2=' + cast ( @st2 as nvarchar ( 10 ) ) + ' nk1=' + cast ( @nk1 as nvarchar ( 10 ) ) + ' nk2=' + cast ( @nk2 as nvarchar ( 10 ) )

				--     			
				set @updatelast = 0
				--     ,    -  
				if ( @lastt = 0 or @lastt is null )
				begin
					--print 'lastt = 0'
					set @updatelast = 1			
				end
				--          -   
				else if ( @dontinsert = 0 ) and ( @actualst = @lastst )
				begin
					--print 'lastst = actualst' + Cast ( @actualst as nvarchar ( 10 ))
					set @lastdstop = @dstop
				end		
				--       
				else
				begin
					--print 'insert time=' + Convert ( nvarchar ( 10 ), @lastdstart, 108 ) + '-' + convert ( nvarchar ( 10 ), @lastdstop, 108 ) + ' state=' + cast ( @lastst as nvarchar ( 10 ) )
					if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
						Insert Into @res
						Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )
				
					set @updatelast = 1	
				end
			
				if ( @updatelast = 1 )
				begin
					if ( @dontinsert = 1 )
			  			set @lastt = 0
					else
 					begin
						set @lastt = @actualt
						set @lastid = @actualid
						set @lastst = @actualst
						set @lastpr = @actualpr
						set @lastdstart = @dstart
						set @lastdstop = @dstop
					end
				end
			
		
				---    () -----
				if ( @nk2 = 1 )
				begin
					if ( @pr2 = 0 )
						set @p0 = @p0 - 1
					else if ( @pr2 = 1 )
						set @p1 = @p1 - 1
					else if ( @pr2 = 2 )
						set @p2 = @p2 - 1
					else if ( @pr2 = 3 )
						set @p3 = @p3 - 1
					else if ( @pr2 = 4 )
						set @p4 = @p4 - 1
					else if ( @pr2 = 5 )
						set @p5 = @p5 - 1
				end
			
				Fetch Next From tcursor Into @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2
			End


			--      ,    
			if ( @dontinsert = 0 )
				if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
					Insert Into @res
					Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )

			Close tcursor
			Deallocate tcursor

			--print '-----curs------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-------------------------------------------------------------------------------------------------
			--          -------------------------------
			-------------------------------------------------------------------------------------------------

			--       (         )
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
				Set 	p0 = @p0, p1 = @p1, p2 = @p2, p3 = @p3, p4 = @p4, p5 = @p5,
					s0 = @s0, s1 = @s1, s2 = @s2, s3 = @s3, s4 = @s4, s5 = @s5,
					LastDT = @dtnow
			Where Id = @idoperator

			Declare @operatorstates table
			(
				Id		int identity ( 1, 1 ) not null primary key,
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int not null,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float,
				ICode		int
			)

			Delete From @operatorstates

			Insert into @operatorstates ( IdOperator, State, DateTimeStart, DateTimeStop, DateStart, TimeStart, LenTime, 
				ICode, IdTask, IsOutput, CallResult )
			Select @idoperator, r.State, r.DStart, r.DStop,
				Cast ( Floor ( Cast ( DStart as Float ) ) as DateTime ),
				Cast ( Cast ( DStart as float ) - Floor ( Cast ( DStart as Float ) ) as DateTime ),				
				Cast ( DStop - DStart as float ) * 86400,
				t2.ICode,
				IdTask, IsOutput, CallResult
			From @res r
				Left join @tempo1 t1 on t1.Id = r.Id and r.TableN = 1
				Left join @tempo2 t2 on t2.State = r.State and t2.DateTimeStart = r.DStart

--Select * From oktell_cc_temp.dbo.A_Cube_CC_OperatorStates os order by DateTimeStart Desc

			--     (     -        )
			Declare @crupdate int
			Select top 1 @crupdate = CallResult 
			From @operatorstates
			Where not IdTask is null	
			
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( TabLock )
			Set CallResult = @crupdate
			Where IdOperator = @idoperator and not IdTask is null and CallResult is null


			--    
			Declare @idt1 int, @state1 int, @dtstart1 DateTime, @dtstop1 DateTime
			
			Select @idt1 = Max ( Id ) 
			From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( TabLock )
			Where IdOperator = @idoperator

			if ( not @idt1 is null )
			   begin
				Select @state1 = State, @dtstart1 = DateTimeStart, @dtstop1 = DateTimeStop 
				From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( TabLock )
				Where Id = @idt1
				
				Declare @idt2 int, @state2 int, @dtstart2 DateTime, @dtstop2 DateTime
				Select Top 1 @idt2 = Id, @state2 = State, @dtstart2 = DateTimeStart, @dtstop2 = DateTimeStop
				From @operatorstates
				Order By DateTimeStart

				if ( @state1 = @state2 ) and ( @dtstart2 = @dtstop1 )
				   begin
					Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( UpdLock )
					Set 	DateTimeStop = @dtstop2,
						LenTime = Cast ( @dtstop2 - @dtstart1 as float ) * 86400
					Where Id = @idt1

					Delete From @operatorstates
					Where Id = @idt2
			   	   end
			   end

		
			--  
			Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( UpdLock )
				( IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime, ICode )
				Select IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime, ICode
				From @operatorstates
			
			--print '-----ins-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

		end
		else
		begin
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
			Set LastDT = @dtnow
			Where Id = @idoperator
		end



	   end
	
	--print '--------------------------------------oper--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @logdt = GetDate ( )
	--Set @operlogdt = GetDate ( )

	Fetch Next From ucursor Into @idoperator, @nameoperator
   end

Close ucursor
Deallocate ucursor

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

	
--Select * FROM [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
--Order by Datetimestart

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

Commit Tran TranUpdateOperatorStates
	
end
GO
