
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_CountRows' ))
	Drop procedure dbo.A_DB_CountRows
GO

Create procedure dbo.A_DB_CountRows
as
Begin
	--        

	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb.dbo.#tabcnt' ))
		Drop table #tabcnt

	Create table #tabcnt ( id int identity(1,1), tablename nvarchar ( 200 ), cnt int )
	
	Truncate table #tabcnt


	Declare tcursor Cursor For
		Select name 
		From sysobjects 
		Where xtype = 'U'

	Declare @sql nvarchar(1000)	
	Declare @tab_name varchar(500)

	Open tcursor
	Fetch Next From tcursor Into @tab_name

	While ( @@fetch_status = 0 ) Begin
		
		Set @sql='Select ''' + @tab_name + ''', Count(*) From dbo.[' + @tab_name + ']'
		
		Insert into #tabcnt (tablename, cnt )
		   Exec sp_executesql @stmt =@sql

		Fetch Next From tcursor Into @tab_name
	End

	Close tcursor
	Deallocate tcursor


	Select * 
	From #tabcnt 
	Order by cnt desc

End
GO




if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_SeedUselessData' ))
	Drop procedure dbo.A_DB_SeedUselessData
GO

Create procedure dbo.A_DB_SeedUselessData
as
Begin
	--        
	--  (    -   )

	Set dateformat dmy
	Declare @dt datetime
	Set @dt = DateAdd ( m, -1, GetDate() )

	Delete
	From A_User_NotifyLog
	Where NotifyDateTime < @dt

	Delete
	From A_TaskManager_UserInTask
	Where TimeStart < @dt 

	Delete
	From A_UserStateHistory
	Where TimeChange < @dt 

	Delete
	From A_CallCenter_UserStateHistory
	Where TimeEnter < @dt 

	Delete
	From A_Stat_Talk_Algorythms 
	Where idconnection not in ( Select id from A_Stat_Connections_1x1 )

	Delete
	From A_CallCenter_LastConnected
	Where ( CallTime < @dt ) and ( idtask not in ( Select id From A_TaskManager_Tasks Where active = 1 ) )

End
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_ClearConstraints' ))
	Drop procedure dbo.A_DB_ClearConstraints
GO

Create procedure [dbo].[A_DB_ClearConstraints]
	@simpletablename nvarchar ( 500 )
as
begin
	--     (  )
	--    ?
	
	Declare @tablename varchar ( 500 )
	Declare @sql nvarchar(1000)
	Set @tablename='dbo.' + @simpletablename

	Declare tcursor Cursor For 
		Select s.name, s.parent_obj, s1.name
		From sysobjects s
			inner join sysobjects s1 on s.parent_obj = s1.Id
		Where s.type = 'F' and s.name like '%' + @simpletablename + '%' 

	Declare @cnstrname varchar(500)
	Declare @parent int
	Declare @subtab varchar ( 500 )


	Open tcursor
	Fetch Next From tcursor Into @cnstrname, @parent, @subtab

	While ( @@fetch_status = 0 ) Begin

		set @sql = ' ALTER TABLE ' + @subtab + 
			' DROP CONSTRAINT ' + @cnstrname
		exec sp_executesql @stmt =@sql
		print @sql

		Fetch Next From tcursor Into @cnstrname, @parent, @subtab
	End
	
	Close tcursor
	Deallocate tcursor

End
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_ClearConstraintsAll' ))
	Drop procedure dbo.A_DB_ClearConstraintsAll
GO

Create procedure [dbo].[A_DB_ClearConstraintsAll]
	@simpletablename nvarchar ( 500 )
as
begin
	
	--      (  )
	--    

	Declare @tablename varchar ( 500 )
	Declare @sql nvarchar(1000)
	Set @tablename='dbo.' + @simpletablename

	Declare tcursor Cursor For 
		Select s.name, s.parent_obj, s1.name
		From sysobjects s
			inner join sysobjects s1 on s.parent_obj = s1.Id
		Where ( s.type = 'F' or s.type = 'K' ) and s.name like '%' + @simpletablename + '%' 
		Order by s.Id Desc

	Declare @cnstrname varchar(500)
	Declare @parent int
	Declare @subtab varchar ( 500 )


	Open tcursor
	Fetch Next From tcursor Into @cnstrname, @parent, @subtab

	While ( @@fetch_status = 0 ) Begin

		Set @sql = ' ALTER TABLE ' + @subtab + 
			' DROP CONSTRAINT ' + @cnstrname
		Exec sp_executesql @stmt =@sql
		Print @sql

		Fetch Next From tcursor Into @cnstrname, @parent, @subtab
	End

	Close tcursor
	Deallocate tcursor

End
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_ClearIndexes' ))
	Drop procedure dbo.A_DB_ClearIndexes
GO

Create procedure [dbo].[A_DB_ClearIndexes]
	@tablename nvarchar ( 500 )
as
begin
	
	Declare @sql nvarchar(1000)

	Declare tcursor Cursor For 
		Select name 
		From sysindexes 
		Where id = object_id(@tablename) 
			and impid >= 0 /*status!=0*/ 
			and name not like '_WA%' 
			and name not like 'PK_%'

	Declare @ind_name varchar(500)

	Open tcursor
	Fetch Next From tcursor Into @ind_name

	While ( @@fetch_status = 0 ) Begin

		Set @sql = 'drop index ' + @tablename + '.' + @ind_name
		Exec sp_executesql @stmt = @sql

		Fetch Next From tcursor Into @ind_name
	End

	Close tcursor
	Deallocate tcursor
End
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_Optimize' ))
	Drop procedure dbo.A_DB_Optimize
GO

Create procedure dbo.A_DB_Optimize
as
begin
	--      


	--        
	-- ( Notify, UserState, UserInTask, LastConnected, TalkAlgorythms )
	exec A_DB_SeedUselessData
	
	----------------------------------------
	--   Oktell
	----------------------------------------

	Declare @logname nvarchar(500)
	Declare @sz int, @msz int
	Declare @curdb nvarchar ( 500 )
	Set @curdb = DB_name()

	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	--  maxsize    1500
	if ( @msz != -1 and @msz < 1500 * 128 )
		Exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', maxsize=1500)')
	Exec ( N'alter database ' + @curdb + ' set recovery simple' )

	--    
	Declare tcursor CURSOR FOR 
		Select name 
		From sysobjects 
		Where xtype = 'U'

	Declare @sql nvarchar(1000)	
	Declare @tab_name varchar(500)

	Open tcursor
	Fetch Next From tcursor Into @tab_name

	While ( @@fetch_status = 0 ) Begin

		Set @sql='DBCC DBREINDEX ( ''dbo.[' + @tab_name + ']'' )'
		Exec sp_executesql @stmt =@sql

		Fetch Next From tcursor Into @tab_name
	End

	Close tcursor
	Deallocate tcursor
	

	Set @sql = 'DBCC SHRINKDATABASE ( ' + db_name() + ' )'
	exec sp_executesql @stmt = @sql

	----------------------------------------
	--  Oktell_CC_Temp
	----------------------------------------

	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	if ( @sz < 500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', size=500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )


	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' ) Begin

		Select @logname = name from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		Select @sz = size, @msz = maxsize from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		if ( @msz != -1 and @msz < 1500 * 128 )
			exec ( N'alter database oktell_cc_temp modify file(name='+@logname+', maxsize=1500)')
		exec ( N'alter database oktell_cc_temp set recovery simple' )

		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_EffortConnections' )
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_OperatorStates' )
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_CallQueue' )

		DBCC SHRINKDATABASE (oktell_cc_temp)
		
		Select @logname = name from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		Select @sz = size, @msz = maxsize from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		if ( @sz < 500 * 128 )
			exec ( N'alter database oktell_cc_temp modify file(name='+@logname+', size=500)')
		exec ( N'alter database oktell_cc_temp set recovery simple' )
	End
End 
GO