If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  if exists ( select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_LangTexts' ))
    Drop table oktell_settings.dbo.A_LangTexts
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  Create table oktell_settings.dbo.A_LangTexts
  (
	id int identity ( 1, 1 ) primary key,
	langkey nvarchar (200),
	langvalue nvarchar (4000)
  )
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  if not exists ( select * from oktell_settings.dbo.sysindexes where name = N'idxLangKey' 
						and id = object_id(N'[oktell_settings].[dbo].[A_LangTexts]'))
    Create index [idxLangKey] ON [oktell_settings].[dbo].[A_LangTexts]
    (
	[langkey]
    ) 
    WITH  FILLFACTOR = 80 ON [PRIMARY]
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_LangTexts' ) and OBJECTPROPERTY(id, N'IsView') = 1)
	Drop view dbo.A_LangTexts
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_LangTexts' ) and OBJECTPROPERTY(id, N'IsTable') = 1)
	Drop table dbo.A_LangTexts
GO


Create View dbo.A_LangTexts
As
	Select *
	From oktell_settings.dbo.A_LangTexts
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Lang_SetData' ))
	Drop procedure dbo.A_Lang_SetData
GO

Create procedure dbo.A_Lang_SetData
	@key nvarchar(200) = '',
	@val nvarchar(4000) = ''
as
Begin
	Update dbo.A_LangTexts
	Set langvalue = @val
	Where langkey like @key

	if ( @@rowcount = 0 ) begin
		Insert into dbo.A_LangTexts ( langkey, langvalue )
		Values ( @key, @val )
	end
End
GO