if exists ( Select * From sysobjects where id= object_id ( 'dbo.A_Clients__GetJournal' ) )
	Drop procedure dbo.A_Clients__GetJournal
GO

Create procedure [dbo].[A_Clients__GetJournal]
	@idclient	uniqueidentifier,
	@dstart		datetime,
	@dstop		datetime,
	@tstart		datetime,
	@tstop		datetime,
	@idoperator	uniqueidentifier,
	@iduser		uniqueidentifier
as
begin
	
	Declare @tstartfloat float
	Declare @tstopfloat float
	Set @tstartfloat =  Convert ( float, @tstart ) - FLOOR ( Convert ( float, @tstart ) )
	Set @tstopfloat =  Convert ( float, @tstop ) - FLOOR ( Convert ( float, @tstop ) )

	--    

	Declare @userspermitted table ( Id uniqueidentifier )
	Insert into @userspermitted
		Select UserB 
		From A_UserControls
		Where UserA = @iduser

	Insert into @userspermitted ( Id ) Values ( @iduser )


	Declare @linespermitted table ( Id uniqueidentifier )
	Insert into @linespermitted
		Select IdLine
		From A_UserControlLines
		Where UserA = @iduser and IdLine != '11111111-1111-1111-1111-111111111111'

	declare @canlistenext int
	Select @canlistenext = Count ( * ) From A_UserControlLines where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

	if ( @canlistenext > 0 )
	Insert into @linespermitted
		Select Id 
		From A_ServerExtLines

	---  

	Select Top 1000 * FROM 
	(
		Select sc.Id, sc.IdChain, 
			sc.TimeStart, 
			sc.TimeAnswer,
			sc.TimeStop,
			Cast ( Cast ( sc.TimeStop - sc.TimeAnswer as float ) * 86400 as int ) as Length,
			AStr as OperatorStr, 
			case when ( u.Id is null and l.Id is null ) then 0 else sc.IsRecorded end as IsRecorded,
			IsNull ( IdRecDir, 0 ) as IdRecDir,
			sc.ALineNum,
			sc.BLineNum,
			--sc.ARecFile,
			--sc.BRecFile,
			0 as Direction
		From A_Stat_Connections_1x1 sc -- with ( TabLock )
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.BOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.BOutNumber) or (sc.BOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id and c.Id = @idclient
			Left join @userspermitted u on sc.AUserId = u.Id
			Left join @linespermitted l on sc.ALineId = l.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.AUserId = @idoperator )

		Union
	
		Select sc.Id, sc.IdChain,
			sc.TimeStart, 
			sc.TimeAnswer,
			sc.TimeStop,
			Cast ( Cast ( sc.TimeStop - sc.TimeAnswer as float ) * 86400 as int ) as Length,
			BStr as OperatorStr, 
			case when ( u.Id is null and l.Id is null ) then 0 else sc.IsRecorded end as IsRecorded,
			IsNull ( IdRecDir, 0 ) as IdRecDir,
			sc.ALineNum,
			sc.BLineNum,
			--sc.ARecFile, 
			--sc.BRecFile,
			1 as Direction
		From A_Stat_Connections_1x1 sc -- with ( TabLock )
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.AOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.AOutNumber) or (sc.AOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id  and c.Id = @idclient	
			Left join @userspermitted u on sc.BUserId = u.Id
			Left join @linespermitted l on sc.BLineId = l.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.BUserId = @idoperator )		

			
	) a

	Order By TimeStart Desc
		
end
GO
