if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_DB_ClearHistoryData' ))
	Drop procedure dbo.A_DB_ClearHistoryData
GO

Create Procedure dbo.A_DB_ClearHistoryData
	@dt DateTime = null
as 
Begin
	--        
	if ( @dt = null )
		Set @dt = Cast ( Floor ( Cast ( GetDate() as Float )) as DateTime)
	-- ...  
	if ( @dt = null )
		Set @dt = Cast ( Floor ( Cast ( GetDate() as Float )) - 1 as DateTime)
	
	--  oktell
	Delete From dbo.A_CallBackOrders Where CalledDateTime < @dt
	Delete From dbo.A_CallCenter_LastConnected Where ( CallTime < @dt ) and ( idtask not in ( Select id From A_TaskManager_Tasks Where active = 1 ) )
	Delete From dbo.A_CallCenter_UserStateHistory Where TimeEnter < @dt
	Delete From dbo.A_CallCenter_ControlEventsJournal Where EventDateTime < @dt
	Delete From dbo.A_ICQMessages Where date_receive < @dt
	Delete From dbo.A_Stat_Comments Where not exists ( Select [id] From A_Stat_Connections_1x1 where id = A_Stat_Comments.[id] )
	Delete From dbo.A_Stat_Conference Where TimeStart < @dt
	Delete From dbo.A_Stat_Conference_Competitors Where not exists ( Select IdConf From A_Stat_Conference Where Id = IdConf )
	Delete From dbo.A_Stat_Conference_RecordAccessUsers Where not exists ( Select IdConf From A_Stat_Conference Where Id = IdConf )
	Delete From dbo.A_Stat_Connections_1x1 Where TimeStart < @dt
	Delete From dbo.A_Stat_Connections_Errors Where TimeStart < @dt
	Delete From dbo.A_Stat_DTMF Where DT < @dt
	Delete From dbo.A_Stat_RingTime Where StartDT < @dt
	Delete From dbo.A_Stat_Talk_Algorythms Where not exists ( Select IdChain From A_Stat_Connections_1x1 Where IdChain = IdConnection )
	Delete From dbo.A_Stat_Talk_StopInfo Where TimeStop < @dt
	Delete From dbo.A_TaskManager_Task_IncomingCalls Where CallTimeStart < @dt
	Delete From dbo.A_TaskManager_SubTaskEfforts Where EDateTime < @dt
	Delete From dbo.A_TaskManager_UserInTask Where TimeStart < @dt
	Delete From dbo.A_User_NotifyLog Where NotifyDateTime < @dt
	Delete From dbo.A_UserMessages Where SentDate < @dt
	Delete From dbo.A_UserStateHistory Where TimeChange < @dt
	Delete From dbo.A_VoiceMail Where SentTime < @dt
	Delete From dbo.A_VoiceMailReceivers where not exists ( Select msgid FROM A_VoiceMail where id = msgid )

	--   ,       , 
	--   ,      . 
	--       (      )
 	--Select * From A_TaskManager_SubTasks
	--Select * From A_TaskManager_SubTaskNumber
	--Select * From A_TaskManager_SubTaskEfforts

	--  oktell_cc_temp
	Delete From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections Where DateTimeStart < @dt
	Delete From oktell_cc_temp.dbo.A_Cube_CC_OperatorStates Where DateTimeStart < @dt
	Delete From oktell_cc_temp.dbo.A_Cube_CC_CallQueue Where DateTimeStart < @dt
End
GO