/****** Object:  StoredProcedure [dbo].[A_Stat_Office_Diagramm_AverageCallTime]    Script Date: 12/15/2011 12:06:47 ******/
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Office_Diagramm_AverageCallTime]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[A_Stat_Office_Diagramm_AverageCallTime]
GO

CREATE procedure [dbo].[A_Stat_Office_Diagramm_AverageCallTime]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@mode int,
	@comment nvarchar(4000) = NULL
as

begin
-- .  "  "


-- ---------------------------------------------------
--declare @iduser uniqueidentifier,
--	@dstart datetime,
--	@dstop datetime,
--	@tstart datetime,
--	@tstop datetime,
--	@lentime datetime,
--	@taskid uniqueidentifier,
--	@fromcc bit,
--	@operatorid uniqueidentifier,
--	@innerprefix nvarchar ( 100 ),
--	@outnumber nvarchar ( 100 ),
--	@conntype int,
--	@mode int,
--	@comment nvarchar(4000)

--select @iduser='08BADA93-618D-4493-A7DC-112E39C1D5B9',
--@dstart='2011-12-1 00:00:00',@dstop='2011-12-13 23:59:59.963',
--@tstart='2006-07-26 00:00:00',@tstop='2006-07-26 23:59:59',
--		@lentime='2006-07-26 00:00:01',
--		@fromcc=1,
--		@conntype=-1,
--		@comment=N'',
--		@mode=4

--------------------------------------------------------------------


	if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		Select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete From #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype,
		0, -- dont show conf
		@comment

	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDdateInt') )
				Select top 0 Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, TimeStop - TimeAnswer length, 1 as count_
				into #tempstatisticsYMDdateInt
				From A_Stat_Connections_1x1
			else
				delete From #tempstatisticsYMDdateInt

			--   111214
			declare @tempdate datetime
			set @tempdate = @dstart
			
			while (@tempdate<@dstop)
			begin
			insert into #tempstatistics (id,timestart,TimeStop, TimeAnswer) --
			values (newid(),@tempdate,@tempdate,@tempdate)
			set @tempdate = dateadd(dd,1,@tempdate)
			end
			
			insert into #tempstatisticsYMDdateInt
				Select Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, Count ( * ) as count_
				From #tempstatistics
				Group By Year( Timestart ), Month ( TimeStart ), Day ( TimeStart )

			--      111214
			update #tempstatisticsYMDdateInt
			set count_ = count_ - 1
			where count_ != 1		
			
			Select y, 
			m, 
			d,
			( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as [avg]
			into #tempstatYMDtabe
			From #tempstatisticsYMDdateInt
			Order by y,m,d
			
			select y,m,d,[avg]as [AverageSec],
					(cast(floor([avg]/3600) as nvarchar (10)))		
					+ ':' + 
					case 
						when floor([avg]/60) - floor([avg]/3600)*60 < 10 then ('0'+cast(floor([avg]/60) - floor(([avg])/3600)*60 as nvarchar (10)))
						when floor([avg]/60) - floor([avg]/3600)*60 >= 10 then (cast(floor([avg]/60) - floor(([avg])/3600)*60 as nvarchar (10)))
					end 
					+':'+
					case 
						when floor([avg]) - floor([avg]/60)*60 < 10 then ('0'+cast(floor([avg]) - floor(([avg])/60)*60 as nvarchar (10)))
						when floor([avg]) - floor([avg]/60)*60 >= 10 then (cast(floor([avg]) - floor(([avg])/60)*60 as nvarchar (10)))
					end 			
					 as Label	
			from #tempstatYMDtabe
			
			drop table #tempstatYMDtabe --   111214
			drop table #tempstatisticsYMDdateInt --   111214		 								
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDHdateInt') )
				Select top 0 DatePart ( hh, TimeStart ) Hstart, TimeStop - TimeAnswer length, 1 as count_
				into #tempstatisticsYMDHdateInt
				From A_Stat_Connections_1x1
			else
				delete From #tempstatisticsYMDHdateInt

			--   111214
			declare @temptime datetime
			set @temptime = @tstart
			
			while (@temptime<@tstop)
			begin
			insert into #tempstatistics (id,timestart,TimeStop, TimeAnswer) --
			values (newid(),@temptime,@temptime,@temptime)
			set @temptime = dateadd(hh,1,@temptime)
			end

			insert into #tempstatisticsYMDHdateInt
				Select DatePart ( hh, TimeStart ) Hstart, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_
				From #tempstatistics
				Group By DatePart ( hh, TimeStart )

			--      111214
			update #tempstatisticsYMDHdateInt
			set count_ = count_ - 1
			where count_ != 1

			Select Hstart, 
			( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as [avg]
			into #tempstatYMDHtabe
			From #tempstatisticsYMDHdateInt
			Order by Hstart
			
			select Hstart,[avg] as [AverageSec],
					(cast(floor([avg]/3600) as nvarchar (10)))		
					+ ':' + 
					case 
						when floor([avg]/60) - floor([avg]/3600)*60 < 10 then ('0'+cast(floor([avg]/60) - floor(([avg])/3600)*60 as nvarchar (10)))
						when floor([avg]/60) - floor([avg]/3600)*60 >= 10 then (cast(floor([avg]/60) - floor(([avg])/3600)*60 as nvarchar (10)))
					end 
					+':'+
					case 
						when floor([avg]) - floor([avg]/60)*60 < 10 then ('0'+cast(floor([avg]) - floor(([avg])/60)*60 as nvarchar (10)))
						when floor([avg]) - floor([avg]/60)*60 >= 10 then (cast(floor([avg]) - floor(([avg])/60)*60 as nvarchar (10)))
					end 			
					 as Label
			from #tempstatYMDHtabe
			
			drop table #tempstatYMDHtabe 
			drop table #tempstatisticsYMDHdateInt
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin	
			Select uid, 
			( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as [avg]
			into #tempstatOPPtabe
			From
			(
				Select uid, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select AUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where AUserId != 'AB000000-0000-0000-0000-000000000000'
	
					Union all
	
					Select BUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where BUserId != 'AB000000-0000-0000-0000-000000000000'
				)a
				Group by uid
			)b
			
			select uid,[avg] as [AverageSec],
					(cast(floor([avg]/3600) as nvarchar (10)))		
					+ ':' + 
					case 
						when floor([avg]/60) - floor([avg]/3600)*60 < 10 then ('0'+cast(floor([avg]/60) - floor(([avg])/3600)*60 as nvarchar (10)))
						when floor([avg]/60) - floor([avg]/3600)*60 >= 10 then (cast(floor([avg]/60) - floor(([avg])/3600)*60 as nvarchar (10)))
					end 
					+':'+
					case 
						when floor([avg]) - floor([avg]/60)*60 < 10 then ('0'+cast(floor([avg]) - floor(([avg])/60)*60 as nvarchar (10)))
						when floor([avg]) - floor([avg]/60)*60 >= 10 then (cast(floor([avg]) - floor(([avg])/60)*60 as nvarchar (10)))
					end 			
					 as Label	
			from #tempstatOPPtabe
			
			drop table #tempstatOPPtabe
			
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines3 table ( lineid uniqueidentifier, caption nvarchar ( 100 ) collate database_default )
			insert into @lines3 (lineid, caption)
				Select id, caption From A_View_ServerLinesAll


			Select linenum + case when (( not l.caption is NULL ) and ( l.caption != '' )) then ', ' + l.caption else '' end as linenum,
				( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as [avg]
			into #tempstatLINEtabe
			From
			(
				Select lineid, linenum, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select ALineId as lineid, ALineNum as linenum, 
						TimeAnswer, TimeStop
					From #tempstatistics ts
					Inner Join @lines3 l on l.lineid = ts.ALineId
	
					Union all
	
					Select BLineId as lineid, BLineNum as linenum, 
						TimeAnswer, TimeStop
					From #tempstatistics ts
					Inner Join @lines3 l on l.lineid = ts.BLineId
				)a
				Group by lineid, linenum
			)b
				Left join @lines3 l on b.lineid = l.lineid
				
			select linenum,[avg] as [AverageSec],
					(cast(floor([avg]/3600) as nvarchar (10)))		
					+ ':' + 
					case 
						when floor([avg]/60) - floor([avg]/3600)*60 < 10 then ('0'+cast(floor([avg]/60) - floor(([avg])/3600)*60 as nvarchar (10)))
						when floor([avg]/60) - floor([avg]/3600)*60 >= 10 then (cast(floor([avg]/60) - floor(([avg])/3600)*60 as nvarchar (10)))
					end 
					+':'+
					case 
						when floor([avg]) - floor([avg]/60)*60 < 10 then ('0'+cast(floor([avg]) - floor(([avg])/60)*60 as nvarchar (10)))
						when floor([avg]) - floor([avg]/60)*60 >= 10 then (cast(floor([avg]) - floor(([avg])/60)*60 as nvarchar (10)))
					end 			
					 as Label	
			from #tempstatLINEtabe
			
			drop table #tempstatLINEtabe	
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner Join A_NumberPlanAction na on na.NumId = np.Id
					Inner Join A_Rules r on na.ExtraId = r.Id
					Inner Join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner Join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end


			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select Id From A_View_ServerLinesAll


			Select prefix, 
			( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as [avg]
			into #tempstatNUMtabe
			From
			(
				Select prefix, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t Inner Join 
						@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 Inner Join 
						A_Users u on u.id = AUserId

					Union all

					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t Inner Join 
						@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 Inner Join 
						A_Users u on u.id = BUserId

					Union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t Inner Join 
						@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = ALineId

					Union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t Inner Join 
						@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = BLineId
				)a
				Group by prefix
			)b
			
			select prefix,[avg] as [AverageSec],
					(cast(floor([avg]/3600) as nvarchar (10)))		
					+ ':' + 
					case 
						when floor([avg]/60) - floor([avg]/3600)*60 < 10 then ('0'+cast(floor([avg]/60) - floor(([avg])/3600)*60 as nvarchar (10)))
						when floor([avg]/60) - floor([avg]/3600)*60 >= 10 then (cast(floor([avg]/60) - floor(([avg])/3600)*60 as nvarchar (10)))
					end 
					+':'+
					case 
						when floor([avg]) - floor([avg]/60)*60 < 10 then ('0'+cast(floor([avg]) - floor(([avg])/60)*60 as nvarchar (10)))
						when floor([avg]) - floor([avg]/60)*60 >= 10 then (cast(floor([avg]) - floor(([avg])/60)*60 as nvarchar (10)))
					end 			
					 as Label	
			from #tempstatNUMtabe
			
			drop table #tempstatNUMtabe	

		end

	--EStatisticsViewMode.svmByWeekDay: // 
	else if ( @mode = 5 )
		begin
			if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDWDdateInt') )
				Select top 0 1 as WDay, CAST(1 as FLOAT) as Seconds, 1 as count_
				into #tempstatisticsYMDWDdateInt
				From A_Stat_Connections_1x1
			else
				delete From #tempstatisticsYMDWDdateInt

			--   
			insert into #tempstatistics (id, Timestart, Timeanswer, Timestop)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-12','2011-12-12','2011-12-12')
			insert into #tempstatistics (id, Timestart, Timeanswer, Timestop)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-13','2011-12-13','2011-12-13')
			insert into #tempstatistics (id, Timestart, Timeanswer, Timestop)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-14','2011-12-14','2011-12-14')
			insert into #tempstatistics (id, Timestart, Timeanswer, Timestop)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-15','2011-12-15','2011-12-15')
			insert into #tempstatistics (id, Timestart, Timeanswer, Timestop)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-16','2011-12-16','2011-12-16')
			insert into #tempstatistics (id, Timestart, Timeanswer, Timestop)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-17','2011-12-17','2011-12-17')
			insert into #tempstatistics (id, Timestart, Timeanswer, Timestop)
			values		('52E72D9F-A37B-4A42-B3A8-0D764B5E2174', '2011-12-18','2011-12-18','2011-12-18')
			
			insert into #tempstatisticsYMDWDdateInt
				select (DatePart(dw, TimeStart)+5)%7 as WDay, 
				ISNULL(SUM(CAST(TimeStop-TimeAnswer as FLOAT))*86400,0) as Seconds, 
				count(*) as count_ 
				From #tempstatistics
				Group by (DatePart(dw, TimeStart)+5)%7
				Order by WDay


			--      111214
			update #tempstatisticsYMDWDdateInt
			set count_ = count_ - 1
			where count_ != 1		
						
			Select WDay, 
			floor(Seconds/count_) as AverageSec
			,  (cast(floor(Seconds/count_/3600) as nvarchar (10)))		
			+ ':' + 
			case 
				when floor(Seconds/count_/60) - floor(Seconds/count_/3600)*60 < 10 then ('0'+cast(floor(Seconds/count_/60) - floor((Seconds/count_)/3600)*60 as nvarchar (10)))
				when floor(Seconds/count_/60) - floor(Seconds/count_/3600)*60 >= 10 then (cast(floor(Seconds/count_/60) - floor((Seconds/count_)/3600)*60 as nvarchar (10)))
			end 
			+':'+
			case 
				when floor(Seconds/count_) - floor(Seconds/count_/60)*60 < 10 then ('0'+cast(floor(Seconds/count_) - floor((Seconds/count_)/60)*60 as nvarchar (10)))
				when floor(Seconds/count_) - floor(Seconds/count_/60)*60 >= 10 then (cast(floor(Seconds/count_) - floor((Seconds/count_)/60)*60 as nvarchar (10)))
			end 			
			 as Label					
			From #tempstatisticsYMDWDdateInt
			order by WDay


			 
			drop table #tempstatisticsYMDWDdateInt
		end
		
	drop table #tempstatistics

end

GO


